﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlServerCe;
using System.Data;
using System.Web.Security;
using System.IO;

namespace Vanny {
    public partial class BuscarCita : System.Web.UI.Page {

        // Local
        public SqlCeConnection con = new SqlCeConnection(@"Data source= " + AppDomain.CurrentDomain.BaseDirectory + "App_Data\\vanny.sdf");
        Login login = new Login();
        int idEmpresa;

        protected void Page_Load(object sender, EventArgs e) {

            //Primero verificamos si el usuario está autenticado usando la propiedad IsAuthenticated. 
            //Si el usuario se autentica, se le redirige directamente a la página de inicio, que se configura como DefaultUrl 
            //en la configuración de autenticación de formularios del archivo Web.Config.

            if (!this.Page.User.Identity.IsAuthenticated) {
                FormsAuthentication.RedirectToLoginPage();
            }

            if (!IsPostBack) {
                ListaCitas(inputSearchC.Value, inputSearchS.Value, Convert.ToInt32(ddMostrar.SelectedValue));
            }

            divLabelError.Visible = false;
            lblError.Visible = false;

        }

        protected void btnSearch_Click(object sender, EventArgs e) {
            ListaCitas(inputSearchC.Value, inputSearchS.Value, Convert.ToInt32(ddMostrar.SelectedValue));
        }

        public void ListaCitas(string filtreCli, string filtreServ, int mostrar) {

            string query = "";
            string userName = User.Identity.Name;
            var list = login.obtenerUsuario(userName);
            idEmpresa = list.idEmpresa;

            DataSet dsCites = new DataSet();
            dsCites.Tables.Add("Cites");

            con.Open();

            if (filtreCli == string.Empty && filtreServ == string.Empty) {

                divLabelError.Visible = true;
                lblError.Text = "Por favor, añada algun filtro.";
                lblError.Visible = true;

                gridCitas.DataSource = null;
                gridCitas.DataBind();

                return;

            } else if (filtreCli == string.Empty && filtreServ != string.Empty) {

                if (mostrar == 3) { // todas
                    query = "SELECT id, titol, descripcio, hora, CONVERT(nvarchar, data, 3) AS data FROM cita " +
                            "WHERE idEmpresa = @empresa and descripcio LIKE @filtreS ORDER BY data, hora asc";
                } else if (mostrar == 1) { // futuro
                    query = "SELECT id, titol, descripcio, hora, CONVERT(nvarchar, data, 3) AS data FROM cita " +
                            "WHERE idEmpresa = @empresa and descripcio LIKE @filtreS AND (CONVERT(nvarchar(10), data, 120) >= '" + DateTime.Today.ToString("yyyy-MM-dd") + "') ORDER BY data, hora asc";
                } else if (mostrar == 2) { // Pasadas
                    query = "SELECT id, titol, descripcio, hora, CONVERT(nvarchar, data, 3) AS data FROM cita " +
                            "WHERE idEmpresa = @empresa and descripcio LIKE @filtreS AND (CONVERT(nvarchar(10), data, 120) < '" + DateTime.Today.ToString("yyyy-MM-dd") + "') ORDER BY data, hora asc";
                }

            } else if (filtreCli != string.Empty && filtreServ == string.Empty) {

                if (mostrar == 3) { // todas
                    query = "SELECT id, titol, descripcio, hora, CONVERT(nvarchar, data, 3) AS data FROM cita " +
                            "WHERE idEmpresa = @empresa and titol LIKE @filtreC ORDER BY data, hora asc";
                } else if (mostrar == 1) { // futuro
                    query = "SELECT id, titol, descripcio, hora, CONVERT(nvarchar, data, 3) AS data FROM cita " +
                            "WHERE (idEmpresa = @empresa) and (titol LIKE @filtreC) and (CONVERT(nvarchar(10), data, 120) >= '" + DateTime.Today.ToString("yyyy-MM-dd") + "') ORDER BY data, hora asc";
                } else if (mostrar == 2) { // Pasadas
                    query = "SELECT id, titol, descripcio, hora, CONVERT(nvarchar, data, 3) AS data FROM cita " +
                            "WHERE (idEmpresa = @empresa) and (titol LIKE @filtreC) AND (CONVERT(nvarchar(10), data, 120) < '" + DateTime.Today.ToString("yyyy-MM-dd") + "') ORDER BY data, hora asc";
                }

            } else if (filtreCli != string.Empty && filtreServ != string.Empty) {

                if (mostrar == 3) { // todas
                    query = "SELECT id, titol, descripcio, hora, CONVERT(nvarchar, data, 3) AS data FROM cita " +
                            "WHERE idEmpresa = @empresa and (titol LIKE @filtreC AND descripcio LIKE @filtreS) ORDER BY data, hora asc";
                } else if (mostrar == 1) { // futuro
                    query = "SELECT id, titol, descripcio, hora, CONVERT(nvarchar, data, 3) AS data FROM cita " +
                            "WHERE idEmpresa = @empresa and (titol LIKE @filtreC AND descripcio LIKE @filtreS) AND (CONVERT(nvarchar(10), data, 120) >= '" + DateTime.Today.ToString("yyyy-MM-dd") + "') ORDER BY data, hora asc";
                } else if (mostrar == 2) { // Pasadas
                    query = "SELECT id, titol, descripcio, hora, CONVERT(nvarchar, data, 3) AS data FROM cita " +
                            "WHERE idEmpresa = @empresa and (titol LIKE @filtreC AND descripcio LIKE @filtreS) AND (CONVERT(nvarchar(10), data, 120) < '" + DateTime.Today.ToString("yyyy-MM-dd") + "') ORDER BY data, hora asc";
                }
            }

            //Cargar lista citas
            SqlCeCommand command = new SqlCeCommand(query, con);
            command.Parameters.AddWithValue("@empresa", idEmpresa);
            command.Parameters.AddWithValue("@filtreC", "%" + filtreCli + "%");
            command.Parameters.AddWithValue("@filtreS", "%" + filtreServ + "%");

            SqlCeDataAdapter adapter = new SqlCeDataAdapter(command);
            adapter.Fill(dsCites.Tables["Cites"]);

            con.Close();

            gridCitas.DataSource = dsCites;
            gridCitas.DataMember = "Cites";
            gridCitas.DataBind();

        }

        protected void ddMostrar_SelectedIndexChanged(object sender, EventArgs e) {
            ListaCitas(inputSearchC.Value, inputSearchS.Value, Convert.ToInt32(ddMostrar.SelectedValue));
        }

    }
}