﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Security;
using System.Data.SqlServerCe;
using System.Data;

namespace Vanny {
    public partial class Caixa : System.Web.UI.Page {

        // Local
        public SqlCeConnection con = new SqlCeConnection(@"Data source= " + AppDomain.CurrentDomain.BaseDirectory + "App_Data\\vanny.sdf");
        Login login = new Login();
        int idEmpresa;

        protected void Page_Load(object sender, EventArgs e) {

            //Primero verificamos si el usuario está autenticado usando la propiedad IsAuthenticated. 
            //Si el usuario se autentica, se le redirige directamente a la página de inicio, que se configura como DefaultUrl 
            //en la configuración de autenticación de formularios del archivo Web.Config.

            if (!this.Page.User.Identity.IsAuthenticated) {
                FormsAuthentication.RedirectToLoginPage();
            }

            if (!IsPostBack) {
                SelectDay.Text = DateTime.Now.ToLongDateString();
                mostrarSaldo();
            }
  
        }

        public void mostrarSaldo() {

            string userName = User.Identity.Name;
            var list = login.obtenerUsuario(userName);
            idEmpresa = list.idEmpresa;

            con.Open();

            string query = "SELECT SUM(fpag1) AS Contado, SUM(fpag2) AS Tarjeta, SUM(iva) AS Iva FROM venda WHERE idEmpresa = @empresa AND (data > @avui and data < @dema)";
            SqlCeCommand command = new SqlCeCommand(query, con);
            command.Parameters.AddWithValue("@empresa", idEmpresa);
            command.Parameters.AddWithValue("@avui", DateTime.Today);
            command.Parameters.AddWithValue("@dema", DateTime.Today.AddDays(1));

            SqlCeDataReader readr = command.ExecuteReader();

            while (readr.Read()) {

                if (readr.IsDBNull(readr.GetOrdinal("Contado")) || readr.IsDBNull(readr.GetOrdinal("Tarjeta"))) {
                    lblTotalCont.Text = "0.00 €";
                    lblTotalTar.Text = "0.00 €";
                    lblImpTotal.Text = "0.00 €";
                    lblImpIva.Text = "0.00 €";
                } else {
                    lblTotalCont.Text = readr.GetDouble(0).ToString()+ " €";
                    lblTotalTar.Text = readr.GetDouble(1).ToString() + " €";
                    lblImpTotal.Text = (readr.GetDouble(0) + readr.GetDouble(1)).ToString() + " €";
                    lblImpIva.Text = readr.GetDouble(2).ToString() + " €";
                }

            }

            con.Close();

        }

        protected void btnCalcTotal_Click(object sender, EventArgs e) {

            double total = 0;

            total =  Convert.ToDouble(
            (check(txtb1C.Text) * 0.01) +
            (check(txtb2C.Text) * 0.02) +
            (check(txtb5C.Text) * 0.05) +
            (check(txtb10C.Text) * 0.10) +
            (check(txtb20C.Text) * 0.20) +
            (check(txtb50C.Text) * 0.50) +
            (check(txtb1E.Text) * 1.00) +
            (check(txtb2E.Text) * 2.00) +
            (check(txtb5E.Text) * 5.00) +
            (check(txtb10E.Text) * 10.00) +
            (check(txtb20E.Text) * 20.00) +
            (check(txtb50E.Text) * 50.00) +
            (check(txtb100E.Text) * 100.00) +
            (check(txtb200E.Text) * 200.00) +
            (check(txtb500E.Text) * 500.00));

            lblTotal.Text = " " + total + "€";

        }

        public int check(string val) {

            if (val == string.Empty) {
                return 0;
            } else {
                return Convert.ToInt32(val);
            }
        }

        protected void btnBorar_Click(object sender, EventArgs e) {

            txtb1C.Text = string.Empty;
            txtb2C.Text = string.Empty;
            txtb5C.Text = string.Empty;
            txtb10C.Text = string.Empty;
            txtb20C.Text = string.Empty;
            txtb50C.Text = string.Empty;
            txtb1E.Text = string.Empty;
            txtb2E.Text = string.Empty;
            txtb5E.Text = string.Empty;
            txtb10E.Text = string.Empty;
            txtb20E.Text = string.Empty;
            txtb50E.Text = string.Empty;
            txtb100E.Text = string.Empty;
            txtb200E.Text = string.Empty;
            txtb500E.Text = string.Empty;
            lblTotal.Text = "0.00 €";
        }
    }
}