﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlServerCe;
using System.Data;
using System.Web.Security;
using System.Drawing;

namespace Vanny {
    public partial class Compte : System.Web.UI.Page {

        // Local
        public SqlCeConnection con = new SqlCeConnection(@"Data source= " + AppDomain.CurrentDomain.BaseDirectory + "App_Data\\vanny.sdf");
        Login login = new Login();
        int idEmpresa;

        protected void Page_Load(object sender, EventArgs e) {

            //Primero verificamos si el usuario está autenticado usando la propiedad IsAuthenticated. 
            //Si el usuario se autentica, se le redirige directamente a la página de inicio, que se configura como DefaultUrl 
            //en la configuración de autenticación de formularios del archivo Web.Config.

            if (!this.Page.User.Identity.IsAuthenticated) {
                FormsAuthentication.RedirectToLoginPage();
            }

            if (!IsPostBack) {

                string userName = User.Identity.Name;
                var list = login.obtenerUsuario(userName);
                idEmpresa = list.idEmpresa;

                // Dades usuari
                txtbUsu.Text = list.usu;
                txtbNom.Text = list.nom;
                txtbEmail.Text = list.email;
                txtbPswAct.Text = list.psw;

                // Dades empresa
                con.Open();
                string query = "select * from empresa where idEmp = @empresa";
                SqlCeCommand command = new SqlCeCommand(query, con);
                command.Parameters.AddWithValue("@empresa", idEmpresa);

                SqlCeResultSet results = command.ExecuteResultSet(ResultSetOptions.Scrollable);

                if (!list.admin) {
                    // Si l'usuari no es administrador no podrá modificar les dades de l'empresa
                    txtbNomEmp.Enabled = false;
                    txtbRSoc.Enabled = false;
                    txtbNIF.Enabled = false;
                    txtbDir.Enabled = false;
                    txtbCP.Enabled = false;
                    txtbPob.Enabled = false;
                    txtbProv.Enabled = false;
                    //txtbPais.Enabled = false;
                    txtbTel1.Enabled = false;
                    //txtbTel2.Enabled = false;
                    txtbMov.Enabled = false;
                    txtbEmailEmp.Enabled = false;
                    txtbIva.Enabled = false;
                    btnGuardarEmp.Disabled = true;
                }

                if (results.HasRows) {

                    results.ReadFirst();
                    txtbNomEmp.Text = results.GetString(0);

                    if (!results.IsDBNull(results.GetOrdinal("raoSocial"))) {
                        txtbRSoc.Text = results.GetString(1);
                    } else {
                        txtbRSoc.Text = "";
                    }

                    txtbNIF.Text = results.GetString(2);
                    txtbDir.Text = results.GetString(3);
                    txtbCP.Text = results.GetString(4);
                    txtbPob.Text = results.GetString(5);
                    txtbProv.Text = results.GetString(6);
                    //txtbPais.Text = results.GetString(7);
                    txtbTel1.Text = results.GetString(8);

                    //if (!results.IsDBNull(results.GetOrdinal("telefon2"))) {
                    //    txtbTel2.Text = results.GetString(9);
                    //} else {
                    //    txtbTel2.Text = "";
                    //}

                    if (!results.IsDBNull(results.GetOrdinal("mobil"))) {
                        txtbMov.Text = results.GetString(10);
                    } else {
                        txtbMov.Text = "";
                    }

                    txtbEmailEmp.Text = results.GetString(11);
                    txtbIva.Text = results.GetDecimal(12).ToString();

                }

                con.Close();

            }

        }

        protected void btnGuardarUsu_Click(object sender, EventArgs e) {

            string userName = User.Identity.Name;
            var list = login.obtenerUsuario(userName);

            con.Open();

            string query = "UPDATE empleat SET usu = @usu, nom = @nom, email = @email WHERE idEmpleat = @empleat and idEmpresa = @empresa";
            SqlCeCommand command = new SqlCeCommand(query, con);
            command.Parameters.AddWithValue("@usu", txtbUsu.Text);
            command.Parameters.AddWithValue("@nom", txtbNom.Text);
            command.Parameters.AddWithValue("@email", txtbEmail.Text);
            command.Parameters.AddWithValue("@empleat", list.idEmpleat);
            command.Parameters.AddWithValue("@empresa", list.idEmpresa);
            command.ExecuteNonQuery();

            con.Close();

        }

        protected void btnNuevaPsw_Click(object sender, EventArgs e) {

            lblOKPsw.Visible = false;

            string userName = User.Identity.Name;
            var list = login.obtenerUsuario(userName);

            // La contrasenya actual ha de ser correcte
            if (list.psw == txtbPswAct.Text) {

                // La contrasenya nova s'ha de repetir dues vegades, ha de coincidir
                if (txtbNewPsw1.Text == txtbNewPsw2.Text) {

                    con.Open();

                    string query = "UPDATE empleat SET psw = @psw WHERE idEmpleat = @empleat and idEmpresa = @empresa";
                    SqlCeCommand command = new SqlCeCommand(query, con);
                    command.Parameters.AddWithValue("@psw", txtbNewPsw1.Text);
                    command.Parameters.AddWithValue("@empleat", list.idEmpleat);
                    command.Parameters.AddWithValue("@empresa", list.idEmpresa);
                    command.ExecuteNonQuery();

                    con.Close();

                    lblOKPsw.Text = "La contraseña se ha actualizado correctamente.";
                    lblOKPsw.ForeColor = Color.RoyalBlue;
                    lblOKPsw.Visible = true;

                } else { 
                    lblOKPsw.Text =  "Las contraseñas introducidas no coinciden.";
                    lblOKPsw.ForeColor = Color.Crimson;
                    lblOKPsw.Visible = true;
                }

            } else {
                lblOKPsw.Text = "La contraseña actual no es correcta.";
                lblOKPsw.ForeColor = Color.Crimson;
                lblOKPsw.Visible = true;
            }

            con.Open();
        }

        protected void btnGuardarEmp_Click(object sender, EventArgs e) {

            string userName = User.Identity.Name;
            var list = login.obtenerUsuario(userName);

            try {

                con.Open();

                string query = "UPDATE empresa SET nom = @nom, raoSocial = @raoSocial, nif = @nif, direccio = @dir, cPostal = @cp, poblacio = @pob, provincia = @prov, telefon1 = @tel, mobil = @mbl, email = @email, iva = @iva WHERE idEmp = @empresa";
                SqlCeCommand command = new SqlCeCommand(query, con);
                command.Parameters.AddWithValue("@nom", txtbNomEmp.Text);
                command.Parameters.AddWithValue("@raoSocial", txtbRSoc.Text);
                command.Parameters.AddWithValue("@nif", txtbNIF.Text);
                command.Parameters.AddWithValue("@dir", txtbDir.Text);
                command.Parameters.AddWithValue("@cp", txtbCP.Text);
                command.Parameters.AddWithValue("@pob", txtbPob.Text);
                command.Parameters.AddWithValue("@prov", txtbProv.Text);
                command.Parameters.AddWithValue("@tel", txtbTel1.Text);
                command.Parameters.AddWithValue("@mbl", txtbMov.Text);
                command.Parameters.AddWithValue("@email", txtbEmailEmp.Text);
                command.Parameters.AddWithValue("@iva", txtbIva.Text);
                command.Parameters.AddWithValue("@empresa", list.idEmpresa);

                command.ExecuteNonQuery();

                lblOKEmp.Text = "Los datos se han actualizado correctamente.";
                lblOKEmp.ForeColor = Color.RoyalBlue;
                lblOKEmp.Visible = true;

            } catch (Exception ex) {

                lblOKEmp.Text = "Los datos no se han podido actualizar.";
                lblOKEmp.ForeColor = Color.Crimson;
                lblOKEmp.Visible = true;
            }

            con.Close();

        }
        

    }
}