﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Security;
using System.Data.SqlServerCe;
using System.Data;

namespace Vanny {
    public partial class EditarDeuda : System.Web.UI.Page {

        // Local
        public SqlCeConnection con = new SqlCeConnection(@"Data source= " + AppDomain.CurrentDomain.BaseDirectory + "App_Data\\vanny.sdf");
        Login login = new Login();
        int idEmpleat, idEmpresa;
        int idDeuda;

        protected void Page_Load(object sender, EventArgs e) {
            //Primero verificamos si el usuario está autenticado usando la propiedad IsAuthenticated. 
            //Si el usuario se autentica, se le redirige directamente a la página de inicio, que se configura como DefaultUrl 
            //en la configuración de autenticación de formularios del archivo Web.Config.

            if (!this.Page.User.Identity.IsAuthenticated) {
                FormsAuthentication.RedirectToLoginPage();
            }

            if (!IsPostBack) {
                mostrarDeuda();
            }

            lblOK.Visible = false;
        }

        public void mostrarDeuda() {
            // Cogemos el id desde la url
            idDeuda = Convert.ToInt32(Request.QueryString["id"]);

            string userName = User.Identity.Name;
            var list = login.obtenerUsuario(userName);
            idEmpresa = list.idEmpresa;

            con.Open();

            string query = "select * from deute where idEmpresa = @empresa and id = @idDeuda";
            SqlCeCommand command = new SqlCeCommand(query, con);
            command.Parameters.AddWithValue("@empresa", idEmpresa);
            command.Parameters.AddWithValue("@idDeuda", idDeuda);

            SqlCeDataReader reader = command.ExecuteResultSet(ResultSetOptions.Scrollable);

            if (reader.HasRows) {
                while (reader.Read()) {

                    inputNom.Text = reader.GetString(1);

                    if (!reader.IsDBNull(reader.GetOrdinal("descripcio"))) {
                        inputDesc.Text = reader.GetString(2);
                    } else {
                        inputDesc.Text = "";
                    }

                    inputImport.Text = reader.GetDecimal(3).ToString();
                    inputCrea.Text = reader.GetDateTime(4).ToShortDateString();
                }
            }

            con.Close();
        }

        protected void btnUpdateDeuda_Click(object sender, EventArgs e) {

            // Cogemos el id desde la url
            idDeuda = Convert.ToInt32(Request.QueryString["id"]);

            string userName = User.Identity.Name;
            var list = login.obtenerUsuario(userName);
            idEmpresa = list.idEmpresa;

            con.Open();

            string query = "UPDATE deute SET nom = @nom, descripcio = @desc, import = @import WHERE id = @idDeuda and idEmpresa = @empresa";

            SqlCeCommand command = new SqlCeCommand(query, con);

            command.Parameters.AddWithValue("@nom", inputNom.Text);
            command.Parameters.AddWithValue("@desc", inputDesc.Text);
            command.Parameters.AddWithValue("@import", inputImport.Text);
            command.Parameters.AddWithValue("@idDeuda", idDeuda);
            command.Parameters.AddWithValue("@empresa", idEmpresa);

            try {
                command.ExecuteNonQuery();
                lblOK.Text = "Los cambios se han guardado correctamente.";
                lblOK.Visible = true;
            } catch (Exception ex) {
                lblOK.Text = "Erro. No se han podido guardar los cambios.";
                lblOK.Visible = true;
            }

            con.Close();

        }

    }
}