﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlServerCe;
using System.Web.Security;
using System.Data;

namespace Vanny {
    public partial class EditarProducto : System.Web.UI.Page {

        // Local
        public SqlCeConnection con = new SqlCeConnection(@"Data source= " + AppDomain.CurrentDomain.BaseDirectory + "App_Data\\vanny.sdf");
        Login login = new Login();
        int idEmpresa;
        int idArt;

        protected void Page_Load(object sender, EventArgs e) {
            //Primero verificamos si el usuario está autenticado usando la propiedad IsAuthenticated. 
            //Si el usuario se autentica, se le redirige directamente a la página de inicio, que se configura como DefaultUrl 
            //en la configuración de autenticación de formularios del archivo Web.Config.

            if (!this.Page.User.Identity.IsAuthenticated) {
                FormsAuthentication.RedirectToLoginPage();
            }

            if (!IsPostBack) {
                mostrarProducto();
            }

            lblOK.Visible = false;
        }

        public void mostrarProducto() {

            // Cogemos el id desde la url
            idArt = Convert.ToInt32(Request.QueryString["id"]);

            string userName = User.Identity.Name;
            var list = login.obtenerUsuario(userName);
            idEmpresa = list.idEmpresa;

            con.Open();

            string query = "select * from article where idEmpresa = @empresa and idArt = @idArt";
            SqlCeCommand command = new SqlCeCommand(query, con);
            command.Parameters.AddWithValue("@empresa", idEmpresa);
            command.Parameters.AddWithValue("@idArt", idArt);

            SqlCeDataReader reader = command.ExecuteResultSet(ResultSetOptions.Scrollable);

            if (reader.HasRows) {

                while (reader.Read()) {

                    inputNom.Text = reader.GetString(1);

                    if (!reader.IsDBNull(reader.GetOrdinal("descripcio"))) {
                        inputDesc.Text = reader.GetString(2);
                    } else {
                        inputDesc.Text = "";
                    }

                    if (!reader.IsDBNull(reader.GetOrdinal("existencies"))) {
                        inputStock.Text = reader.GetInt32(3).ToString();
                    } else {
                        inputStock.Text = "";
                    }

                    if (!reader.IsDBNull(reader.GetOrdinal("stockIdeal"))) {
                        inputStockIdeal.Text = reader.GetInt32(12).ToString();
                    } else {
                        inputStockIdeal.Text = "";
                    }

                    inputPVP.Text = reader.GetDouble(5).ToString();
                    inputFab.Text = reader.GetString(6);
                    inputData.Text = reader.GetDateTime(7).ToShortDateString();
                    ddTipo.SelectedValue = reader.GetBoolean(8).ToString();
                    inputRefFab.Text = reader.GetString(9);

                    cargarFam();
                    cargarSubFam();

                    ddFam.SelectedValue = pasarFam(reader.GetInt32(10).ToString());
                    ddSubFam.SelectedValue = reader.GetInt32(10).ToString();

                }

            }

            con.Close();

        }

        public string pasarFam(string subfam) {

            string codSubFam = "";

            string q = "SELECT id, codFam, codSubFam, nom FROM subfamilia WHERE (codSubFam = @subFam)";

            //Cargar subfamilies
            SqlCeCommand cmd = new SqlCeCommand(q, con);
            cmd.Parameters.AddWithValue("@subFam", Convert.ToInt32(subfam));

            SqlCeDataReader readr = cmd.ExecuteReader();

            while (readr.Read()) {
                codSubFam = readr.GetValue(1).ToString();
            }

            return codSubFam;

        }

        public void cargarFam() {

            DataSet dsFam = new DataSet();
            string query = "select * from familia order by id ASC";

            //con.Open();

            //Cargar families
            SqlCeCommand command = new SqlCeCommand(query, con);
            SqlCeDataAdapter adapter = new SqlCeDataAdapter(command);
            adapter.Fill(dsFam);

            //con.Close();

            ddFam.DataSource = dsFam;
            ddFam.DataTextField = "nom";
            ddFam.DataValueField = "codFam";
            ddFam.DataBind();

        }

        public void cargarSubFam() {

            DataSet dsSubFam = new DataSet();
            string query = "select * from subfamilia order by id ASC";

            //con.Open();

            //Cargar families
            SqlCeCommand command = new SqlCeCommand(query, con);
            SqlCeDataAdapter adapter = new SqlCeDataAdapter(command);
            adapter.Fill(dsSubFam);

            //con.Close();

            ddSubFam.DataSource = dsSubFam;
            ddSubFam.DataTextField = "nom";
            ddSubFam.DataValueField = "codSubFam";
            ddSubFam.DataBind();

        }

        protected void ddFam_SelectedIndexChanged(object sender, EventArgs e) {

            DataSet dsSubFam = new DataSet();

            string query = "select * from subfamilia WHERE codFam = @codFam order by id ASC";

            con.Open();

            //Cargar subfamilies
            SqlCeCommand command = new SqlCeCommand(query, con);
            command.Parameters.AddWithValue("@codFam", Convert.ToInt32(ddFam.SelectedValue));

            SqlCeDataAdapter adapter = new SqlCeDataAdapter(command);
            adapter.Fill(dsSubFam);

            con.Close();

            ddSubFam.DataSource = dsSubFam;
            ddSubFam.DataTextField = "nom";
            ddSubFam.DataValueField = "codSubFam";
            ddSubFam.DataBind();

        }

        protected void btnUpdateProd_Click(object sender, EventArgs e) {

             // Cogemos el id desde la url
            idArt = Convert.ToInt32(Request.QueryString["id"]);

            string userName = User.Identity.Name;
            var list = login.obtenerUsuario(userName);
            idEmpresa = list.idEmpresa;

            con.Open();

            string query = "UPDATE article SET nom = @nom, descripcio = @desc, existencies = @stock, preuVenda = @pvp, fabricant = @fab, " +
                           "dataAlta = @alta, servei = @servei, reffab = @reffab, codSubFam = @subfam, stockIdeal = @stockIdeal WHERE idArt = @idArt and idEmpresa = @empresa";

            SqlCeCommand command = new SqlCeCommand(query, con);
            command.Parameters.AddWithValue("@nom", inputNom.Text);

            if (inputDesc.Text == string.Empty) {
                command.Parameters.AddWithValue("@desc", DBNull.Value);
            } else {
                command.Parameters.AddWithValue("@desc", inputDesc.Text);
            }

            if (inputStock.Text == string.Empty) {
                command.Parameters.AddWithValue("@stock", DBNull.Value);
            } else {
                command.Parameters.AddWithValue("@stock", Convert.ToInt32(inputStock.Text));
            }

            if (inputStockIdeal.Text == string.Empty) {
                command.Parameters.AddWithValue("@stockIdeal", DBNull.Value);
            } else {
                command.Parameters.AddWithValue("@stockIdeal", Convert.ToInt32(inputStockIdeal.Text));
            }

            //command.Parameters.AddWithValue("@preuultcomp", inputPoblacio.Text);
            command.Parameters.AddWithValue("@pvp", Convert.ToDecimal(inputPVP.Text));
            command.Parameters.AddWithValue("@fab", inputFab.Text);
            command.Parameters.AddWithValue("@alta", Convert.ToDateTime(inputData.Text));
            command.Parameters.AddWithValue("@servei", Convert.ToBoolean(ddTipo.SelectedValue));
            command.Parameters.AddWithValue("@reffab", inputRefFab.Text);
            command.Parameters.AddWithValue("@subfam", Convert.ToInt32(ddSubFam.SelectedValue));
            command.Parameters.AddWithValue("@idArt", idArt);
            command.Parameters.AddWithValue("@empresa", idEmpresa);

            try {
                command.ExecuteNonQuery();
                lblOK.Text = "Los cambios se han guardado correctamente.";
                lblOK.CssClass = "alert alert-primary";
                lblOK.Visible = true;
            } catch (Exception ex) {
                lblOK.Text = "Error. No se han podido guardar los cambios.";
                lblOK.CssClass = "alert alert-danger";
                lblOK.Visible = true;
            }

            con.Close();

        }

        protected void ddTipo_SelectedIndexChanged(object sender, EventArgs e) {

            if (inputStock.Text != "") {
                if (ddTipo.SelectedValue == "True") {
                    lblOK.Text = "No se pueden guardar existencias en un servicio.";
                    lblOK.CssClass = "alert alert-danger";
                    lblOK.Visible = true;

                    inputStock.Text = string.Empty;
                    inputStockIdeal.Text = string.Empty;
                }
            }
        }

        protected void inputStock_TextChanged(object sender, EventArgs e) {

            if (inputStock.Text != "") {
                if (ddTipo.SelectedValue == "True") {

                    lblOK.Text = "No se pueden guardar existencias en un servicio.";
                    lblOK.CssClass = "alert alert-danger";
                    lblOK.Visible = true;

                    inputStock.Text = string.Empty;
                    inputStockIdeal.Text = string.Empty;
                }
            }
        }

        protected void inputStockIdeal_TextChanged(object sender, EventArgs e) {

            if (inputStockIdeal.Text != "") {
                if (ddTipo.SelectedValue == "True") {

                    lblOK.Text = "No se puede guarar stock ideal en un servicio.";
                    lblOK.CssClass = "alert alert-danger";
                    lblOK.Visible = true;

                    inputStock.Text = string.Empty;
                    inputStockIdeal.Text = string.Empty;
                }
            }
        }

    }
}