﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlServerCe;
using System.Data;
using System.Web.Security;

namespace Vanny {
    public partial class EditarProveedor : System.Web.UI.Page {

        // BD Local
        public SqlCeConnection con = new SqlCeConnection(@"Data source= " + AppDomain.CurrentDomain.BaseDirectory + "App_Data\\vanny.sdf");
        Login login = new Login();
        int idEmpresa;
        int idProve;

        protected void Page_Load(object sender, EventArgs e) {

            //Primero verificamos si el usuario está autenticado usando la propiedad IsAuthenticated. 
            //Si el usuario se autentica, se le redirige directamente a la página de inicio, que se configura como DefaultUrl 
            //en la configuración de autenticación de formularios del archivo Web.Config.

            if (!this.Page.User.Identity.IsAuthenticated) {
                FormsAuthentication.RedirectToLoginPage();
            }

            if (!IsPostBack) {
                mostrarProve();
            }

            lblOK.Visible = false;
        }

         public void mostrarProve() {

            // Cogemos el id desde la url
            idProve = Convert.ToInt32(Request.QueryString["id"]);

            string userName = User.Identity.Name;
            var list = login.obtenerUsuario(userName);
            idEmpresa = list.idEmpresa;

            con.Open();

            string query = "SELECT * FROM proveidor WHERE idEmpresa = @empresa and idProve = @idProve";
            SqlCeCommand command = new SqlCeCommand(query, con);
            command.Parameters.AddWithValue("@empresa", idEmpresa);
            command.Parameters.AddWithValue("@idProve", idProve);

            SqlCeDataReader reader = command.ExecuteResultSet(ResultSetOptions.Scrollable);

            if (reader.HasRows) {

                while (reader.Read()) {

                    inputNom.Text = reader.GetString(1);

                    if (!reader.IsDBNull(reader.GetOrdinal("raoSocial"))) {
                        inputRaoSocial.Text = reader.GetString(2);
                    } else {
                        inputRaoSocial.Text = "";
                    }

                    if (!reader.IsDBNull(reader.GetOrdinal("direccio"))) {
                        inputDireccio.Text = reader.GetString(3);
                    } else {
                        inputDireccio.Text = "";
                    }

                    if (!reader.IsDBNull(reader.GetOrdinal("poblacio"))) {
                        inputPoblacio.Text = reader.GetString(4);
                    } else {
                        inputPoblacio.Text = "";
                    }

                    if (!reader.IsDBNull(reader.GetOrdinal("provincia"))) {
                        inputProvincia.Text = reader.GetString(10);
                    } else {
                        inputProvincia.Text = "";
                    }

                    if (!reader.IsDBNull(reader.GetOrdinal("telefon"))) {
                        inputTelefono.Text = reader.GetString(5);
                    } else {
                        inputTelefono.Text = "";
                    }

                    if (!reader.IsDBNull(reader.GetOrdinal("mobil"))) {
                        inputMvl.Text = reader.GetString(6);
                    } else {
                        inputMvl.Text = "";
                    }

                    if (!reader.IsDBNull(reader.GetOrdinal("email"))) {
                        inputEmail.Text = reader.GetString(7);
                    } else {
                        inputEmail.Text = "";
                    }

                    if (!reader.IsDBNull(reader.GetOrdinal("contacte"))) {
                        inputContact.Text = reader.GetString(8);
                    } else {
                        inputContact.Text = "";
                    }
                }

            }

            con.Close();

        }

        protected void btnUpdateProve_Click(object sender, EventArgs e) {

            // Cogemos el id desde la url
            idProve = Convert.ToInt32(Request.QueryString["id"]);

            string userName = User.Identity.Name;
            var list = login.obtenerUsuario(userName);
            idEmpresa = list.idEmpresa;

            con.Open();

            string query = "UPDATE proveidor SET nom = @nom, raoSocial = @raoSocial, direccio = @dir, poblacio = @pob, provincia = @provincia, contacte = @contact, "+
                           "telefon = @tel, mobil = @mbl, email = @email WHERE idProve = @idProve and idEmpresa = @empresa";

            SqlCeCommand command = new SqlCeCommand(query, con);
            
            command.Parameters.AddWithValue("@nom", inputNom.Text);
            command.Parameters.AddWithValue("@raoSocial", inputRaoSocial.Text);
            command.Parameters.AddWithValue("@dir", inputDireccio.Text);
            command.Parameters.AddWithValue("@pob", inputPoblacio.Text);
            command.Parameters.AddWithValue("@provincia", inputProvincia.Text);
            command.Parameters.AddWithValue("@contact", inputContact.Text);
            command.Parameters.AddWithValue("@tel", inputTelefono.Text);
            command.Parameters.AddWithValue("@mbl", inputMvl.Text);
            command.Parameters.AddWithValue("@email", inputEmail.Text);
            command.Parameters.AddWithValue("@idProve", idProve);
            command.Parameters.AddWithValue("@empresa", idEmpresa);

            try {
                command.ExecuteNonQuery();
                lblOK.Text = "Los cambios se han guardado correctamente.";
                lblOK.Visible = true;
            } catch (Exception ex) {
                lblOK.Text = "Erro. No se han podido guardar los cambios.";
                lblOK.Visible = true;
            }

            con.Close();

        }

    }


}